routes/web.php
<?php

use Illuminate\Support\Facades\Artisan;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
Route::get('/clear', function() {
    Artisan::call('cache:clear');
    Artisan::call('config:clear');
    Artisan::call('config:cache');
    Artisan::call('view:clear');
    return "Cleared!";
});
Auth::routes(['register'=>false]);

Route::get('/', 'HomeController@welcome')->name('welcome');
Route::get('/home', 'HomeController@index')->name('home');
Route::get('/product/{id}', 'HomeController@product')->name('product');
Route::get('/our/product', 'HomeController@ourProduct')->name('our.product');
Route::get('/about/us', 'HomeController@aboutUs')->name('about.us');
Route::get('/contact/us', 'HomeController@contactUs')->name('contact.us');

Route::group(['as'=>'admin.','prefix'=>'admin','namespace'=>'Admin','middleware'=>['auth','admin','history']], function () {
    Route::get('/dashboard','DashboardController@index')->name('dashboard');

    Route::get('/logo/name','DashboardController@logoName')->name('logo.name');
    Route::put('/logo/name/update','DashboardController@logoNameUpdate')->name('logo.name.update');

    Route::get('/social','DashboardController@social')->name('social');
    Route::put('/social/update','DashboardController@socialUpdate')->name('social.update');

    Route::get('/contact','DashboardController@contact')->name('contact');
    Route::put('/contact/update','DashboardController@contactUpdate')->name('contact.update');

    Route::get('/about/us','DashboardController@aboutUs')->name('about.us');
    Route::put('/about/us/update','DashboardController@aboutUsUpdate')->name('about-us.update');

    Route::get('/category/add','CategoryController@category')->name('category');
    Route::post('/category/add/add','CategoryController@categoryAdd')->name('category.add');
    Route::get('/category/view','CategoryController@categoryView')->name('category.view');
    Route::get('/category/edit{id}','CategoryController@categoryEdit')->name('category.edit');
    Route::put('/category/update{id}','CategoryController@categoryUpdate')->name('category.update');
    Route::delete('/category/delete{id}','CategoryController@categoryDelete')->name('category.delete');

    Route::get('/product/add','ProductController@product')->name('product');
    Route::post('/product/add/add','ProductController@productAdd')->name('product.add');
    Route::get('/product/{id}edit','ProductController@productedit')->name('product.edit');
    Route::get('/product/view','ProductController@productView')->name('product.view');
    Route::put('/product{id}/update','ProductController@productUpdate')->name('product.update');
    Route::delete('/product/delete{id}','ProductController@productDelete')->name('product.delete');

});

app/Category.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Category extends Model
{
    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name',
    ];
    public function products(){
      return  $this->hasMany(Product::class);
    }
}

app/Http/Controllers/Admin/CategoryController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Category;
use App\Http\Controllers\Controller;
use Brian2694\Toastr\Facades\Toastr;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Validator;

class CategoryController extends Controller
{
    public function category(){
        return view('Admin.add_category');
    }
    public function categoryAdd(Request $request){
        $val = Validator::make($request->all(),[
            'name'=>'required|string|max:191|unique:categories,name',
        ]);
        if ($val->fails()){
            Toastr::error('Invalid Request!!','Error');
            return redirect()->back();
        }
        $category = new Category();
        $category->name = $request->name;
        $category->save();
        Toastr::success('Successfully Added','Success');
        return redirect()->back();
    }
    public function categoryView(){
        $categories = Category::all();
        return view('Admin.Category.index',compact('categories'));
    }
    public function categoryEdit($id){
        $cat = Category::findOrFail($id);
        if (isset($cat->id)){
            return view('Admin.Category.edit',compact('cat'));
        }
        Toastr::error('Invalid Request','Error');
        return redirect()->back();
    }
    public function categoryUpdate(Request $request, $id){
        //dd($id);
        $val = Validator::make($request->all(),[
            'name'=>'required|string|max:191',
        ]);
        if ($val->fails()){
            Toastr::error('Invalid Request!!','Error');
            return redirect()->back();
        }
        $category=Category::findOrFail($id);
        $category->name = $request->name;
        $category->save();
        Toastr::success('Successfully Update','Success');
        return redirect()->back();
    }
    public function categoryDelete($id){
        $category = Category::findOrFail($id);
        if (isset($category->id)){
            if($category->products->count() >0){
                Toastr::error('This category have product. you cant delete this category.','Error');
                return redirect()->back();
            }
            $category->delete();
            Toastr::success('Successfully delete','Success');
            return redirect()->back();
        }
        Toastr::error('Invalid request','Error');
        return redirect()->back();
    }
}

resources/views/Admin/Category/edit.blade.php
@extends('layouts.backend.app')

@section('title','Edit')

@push('css')
    <!-- Bootstrap Select Css -->
    <link href="{{ asset('assets/backend/plugins/bootstrap-select/css/bootstrap-select.css') }}" rel="stylesheet" />
@endpush

@section('content')
    <div class="container-fluid">

        <!-- Vertical Layout | With Floating Label -->
        <div class="row clearfix">
            <form action="{{ route('admin.category.update',$cat->id) }}" method="POST">
                @csrf
                @method('PUT')
                <div class="col-lg-8 col-md-12 col-sm-12 col-xs-12">
                    <div class="card">
                        <div class="header">
                            <h2>
                                Update Category
                            </h2>
                        </div>
                        <div class="body">
                            <div class="form-group form-float">
                                <div class="form-line">
                                    <input type="text" id="title" class="form-control" name="name" value="{{ $cat->name }}">
                                    <label class="form-label">Name</label>
                                </div>
                            </div>
                            <div class="card">
                                <div class="header">
                                </div>
                                <a class="btn btn-danger m-t-15 waves-effect" href="{{ route('admin.category.view') }}">Back</a>
                                <button type="submit" class="btn btn-primary m-t-15 waves-effect">Update</button>
                            </div>
                        </div>
                    </div>
                </div>
            </form>
        </div>
        <!-- Vertical Layout | With Floating Label -->
    </div>

@endsection

@push('js')
    <!-- Select Plugin Js -->
    <script src="{{ asset('assets/backend/plugins/bootstrap-select/js/bootstrap-select.js') }}"></script>
@endpush

resources/views/Admin/Category/index.blade.php
@extends('layouts.backend.app')

@section('title','Category')

@push('css')
    <!-- JQuery DataTable Css -->
    <link href="{{ asset('assets/backend/plugins/jquery-datatable/skin/bootstrap/css/dataTables.bootstrap.css') }}" rel="stylesheet">
@endpush

@section('content')
    <div class="container-fluid">
        <div class="block-header">
            <a class="btn btn-primary waves-effect" href="{{ route('admin.category') }}">
                <i class="material-icons">add</i>
                <span>Add New Category</span>
            </a>
        </div>
        <!-- Exportable Table -->
        <div class="row clearfix">
            <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
                <div class="card">
                    <div class="header">
                        <h2>
                            ALL CATEGORIES
                            <span class="badge bg-blue">{{ $categories->count() }}</span>
                        </h2>
                    </div>
                    <div class="body">
                        <div class="table-responsive">
                            <table class="table table-bordered table-striped table-hover dataTable js-exportable">
                                <thead>
                                <tr>
                                    <th>SL</th>
                                    <th>Category Name</th>
                                    <th>Total Items</th>
                                    <th>Updated At</th>
                                    <th>Action</th>
                                </tr>
                                </thead>
                                <tfoot>
                                <tr>
                                    <th>SL</th>
                                    <th>Category Name</th>
                                    <th>Total Items</th>
                                    <th>Updated At</th>
                                    <th>Action</th>
                                </tr>
                                </tfoot>
                                <tbody>
                                @foreach($categories as $key=>$category)
                                    <tr>
                                        <td>{{ $key + 1 }}</td>
                                        <td>{{ $category->name }}</td>
                                        <td>{{ $category->products->count() }}</td>
                                        <td>{{ $category->updated_at }}</td>
                                        <td class="text-center">
                                            <a href="{{ route('admin.category.edit',$category->id) }}" class="btn btn-info waves-effect">
                                                <i class="material-icons">edit</i>
                                            </a>
                                            <button class="btn btn-danger waves-effect" type="button" onclick="deleteCategory({{ $category->id }})">
                                                <i class="material-icons">delete</i>
                                            </button>
                                            <form id="delete-form-{{ $category->id }}" action="{{ route('admin.category.delete',$category->id) }}" method="POST" style="display: none;">
                                                @csrf
                                                @method('DELETE')
                                            </form>
                                        </td>
                                    </tr>
                                @endforeach
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <!-- #END# Exportable Table -->
    </div>
@endsection

@push('js')
    <!-- Jquery DataTable Plugin Js -->
    <script src="{{ asset('assets/backend/plugins/jquery-datatable/jquery.dataTables.js') }}"></script>
    <script src="{{ asset('assets/backend/plugins/jquery-datatable/skin/bootstrap/js/dataTables.bootstrap.js') }}"></script>
    <script src="{{ asset('assets/backend/plugins/jquery-datatable/extensions/export/dataTables.buttons.min.js') }}"></script>
    <script src="{{ asset('assets/backend/plugins/jquery-datatable/extensions/export/buttons.flash.min.js') }}"></script>
    <script src="{{ asset('assets/backend/plugins/jquery-datatable/extensions/export/jszip.min.js') }}"></script>
    <script src="{{ asset('assets/backend/plugins/jquery-datatable/extensions/export/pdfmake.min.js') }}"></script>
    <script src="{{ asset('assets/backend/plugins/jquery-datatable/extensions/export/vfs_fonts.js') }}"></script>
    <script src="{{ asset('assets/backend/plugins/jquery-datatable/extensions/export/buttons.html5.min.js') }}"></script>
    <script src="{{ asset('assets/backend/plugins/jquery-datatable/extensions/export/buttons.print.min.js') }}"></script>

    <script src="{{ asset('assets/backend/js/pages/tables/jquery-datatable.js') }}"></script>
    <script src="https://unpkg.com/sweetalert2@7.19.1/dist/sweetalert2.all.js"></script>
    <script type="text/javascript">
        function deleteCategory(id) {
            swal({
                title: 'Are you sure?',
                text: "You won't be able to revert this!",
                type: 'warning',
                showCancelButton: true,
                confirmButtonColor: '#3085d6',
                cancelButtonColor: '#d33',
                confirmButtonText: 'Yes, delete it!',
                cancelButtonText: 'No, cancel!',
                confirmButtonClass: 'btn btn-success',
                cancelButtonClass: 'btn btn-danger',
                buttonsStyling: false,
                reverseButtons: true
            }).then((result) => {
                if (result.value) {
                    event.preventDefault();
                    document.getElementById('delete-form-'+id).submit();
                } else if (
                    // Read more about handling dismissals
                    result.dismiss === swal.DismissReason.cancel
                ) {
                    swal(
                        'Cancelled',
                        'Your data is safe :)',
                        'error'
                    )
                }
            })
        }
    </script>
@endpush